diff --git a/test/validation/buffer/buffer.h b/test/validation/buffer/buffer.h
index 44d05a2..6269c63 100644
--- a/test/validation/buffer/buffer.h
+++ b/test/validation/buffer/buffer.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:	BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_BUFFER_H_
+#define _ODP_TEST_BUFFER_H_
+
 int buffer_main(void);
+
+#endif
diff --git a/test/validation/classification/classification.h b/test/validation/classification/classification.h
index e677343..63ad022 100644
--- a/test/validation/classification/classification.h
+++ b/test/validation/classification/classification.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_CLASSIFICATION_H_
+#define _ODP_TEST_CLASSIFICATION_H_
+
 int classification_main(void);
+
+#endif
diff --git a/test/validation/cpumask/cpumask.h b/test/validation/cpumask/cpumask.h
index c0d19a9..2c6fb4a 100644
--- a/test/validation/cpumask/cpumask.h
+++ b/test/validation/cpumask/cpumask.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_CPUMASK_H_
+#define _ODP_TEST_CPUMASK_H_
+
 int cpumask_main(void);
+
+#endif
diff --git a/test/validation/crypto/crypto.h b/test/validation/crypto/crypto.h
index aacb511..9ab641b 100644
--- a/test/validation/crypto/crypto.h
+++ b/test/validation/crypto/crypto.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_CRYPTO_H_
+#define _ODP_TEST_CRYPTO_H_
+
 int crypto_main(void);
+
+#endif
diff --git a/test/validation/crypto/test_vectors.h b/test/validation/crypto/test_vectors.h
index 369fc16..490a3bc 100644
--- a/test/validation/crypto/test_vectors.h
+++ b/test/validation/crypto/test_vectors.h
@@ -4,6 +4,9 @@
  * SPDX-License-Identifier:	BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_CRYPTO_VECTORS_H_
+#define _ODP_TEST_CRYPTO_VECTORS_H_
+
 #include "test_vectors_len.h"
 /* TDES-CBC reference vectors, according to
  * "http://csrc.nist.gov/groups/STM/cavp/documents/des/DESMMT.pdf"
@@ -83,3 +86,5 @@ static uint8_t hmac_md5_reference_digest[][HMAC_MD5_DIGEST_LEN] = {
 	{ 0x56, 0xbe, 0x34, 0x52, 0x1d, 0x14, 0x4c, 0x88,
 	  0xdb, 0xb8, 0xc7, 0x33, 0xf0, 0xe8, 0xb3, 0xf6 }
 };
+
+#endif
diff --git a/test/validation/errno/errno.h b/test/validation/errno/errno.h
index f05d2c6..5923768 100644
--- a/test/validation/errno/errno.h
+++ b/test/validation/errno/errno.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_ERRNO_H_
+#define _ODP_TEST_ERRNO_H_
+
 int errno_main(void);
+
+#endif
diff --git a/test/validation/init/init.h b/test/validation/init/init.h
index ca03994..7e5a082 100644
--- a/test/validation/init/init.h
+++ b/test/validation/init/init.h
@@ -4,6 +4,11 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_INIT_H_
+#define _ODP_TEST_INIT_H_
+
 int init_main_abort(void);
 int init_main_log(void);
 int init_main_ok(void);
+
+#endif
diff --git a/test/validation/packet/packet.h b/test/validation/packet/packet.h
index 421bc25..7e210cb 100644
--- a/test/validation/packet/packet.h
+++ b/test/validation/packet/packet.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:	BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_PACKET_H_
+#define _ODP_TEST_PACKET_H_
+
 int packet_main(void);
+
+#endif
diff --git a/test/validation/pktio/pktio.h b/test/validation/pktio/pktio.h
index 4b6d512..ccf5268 100644
--- a/test/validation/pktio/pktio.h
+++ b/test/validation/pktio/pktio.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_PKTIO_H_
+#define _ODP_TEST_PKTIO_H_
+
 int pktio_main(void);
+
+#endif
diff --git a/test/validation/pool/pool.h b/test/validation/pool/pool.h
index 53cd4d1..8c73d9b 100644
--- a/test/validation/pool/pool.h
+++ b/test/validation/pool/pool.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:	BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_POOL_H_
+#define _ODP_TEST_POOL_H_
+
 int pool_main(void);
+
+#endif
diff --git a/test/validation/queue/queue.h b/test/validation/queue/queue.h
index 3e9a9f1..8302912 100644
--- a/test/validation/queue/queue.h
+++ b/test/validation/queue/queue.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_QUEUE_H_
+#define _ODP_TEST_QUEUE_H_
+
 int queue_main(void);
+
+#endif
diff --git a/test/validation/random/random.h b/test/validation/random/random.h
index c40ee1f..34e375c 100644
--- a/test/validation/random/random.h
+++ b/test/validation/random/random.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_RANDOM_H_
+#define _ODP_TEST_RANDOM_H_
+
 int random_main(void);
+
+#endif
diff --git a/test/validation/scheduler/scheduler.h b/test/validation/scheduler/scheduler.h
index f2d5795..db0f289 100644
--- a/test/validation/scheduler/scheduler.h
+++ b/test/validation/scheduler/scheduler.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_SCHEDULER_H_
+#define _ODP_TEST_SCHEDULER_H_
+
 int scheduler_main(void);
+
+#endif
diff --git a/test/validation/shmem/shmem.h b/test/validation/shmem/shmem.h
index 9b79027..f9cf523 100644
--- a/test/validation/shmem/shmem.h
+++ b/test/validation/shmem/shmem.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_SHMEM_H_
+#define _ODP_TEST_SHMEM_H_
+
 int shmem_main(void);
+
+#endif
diff --git a/test/validation/synchronizers/synchronizers.h b/test/validation/synchronizers/synchronizers.h
index 8890c3d..8a93187 100644
--- a/test/validation/synchronizers/synchronizers.h
+++ b/test/validation/synchronizers/synchronizers.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_SYNCHRONIZERS_H_
+#define _ODP_TEST_SYNCHRONIZERS_H_
+
 int synchronizers_main(void);
+
+#endif
diff --git a/test/validation/system/system.h b/test/validation/system/system.h
index 92618fb..f00ae57 100644
--- a/test/validation/system/system.h
+++ b/test/validation/system/system.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:	BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_SYSTEM_H_
+#define _ODP_TEST_SYSTEM_H_
+
 int system_main(void);
+
+#endif
diff --git a/test/validation/thread/thread.h b/test/validation/thread/thread.h
index 94c288e..c0cbb34 100644
--- a/test/validation/thread/thread.h
+++ b/test/validation/thread/thread.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_THREAD_H_
+#define _ODP_TEST_THREAD_H_
+
 int thread_main(void);
+
+#endif
diff --git a/test/validation/time/time.h b/test/validation/time/time.h
index 30c2fdc..1cd54d9 100644
--- a/test/validation/time/time.h
+++ b/test/validation/time/time.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_TIME_H_
+#define _ODP_TEST_TIME_H_
+
 int time_main(void);
+
+#endif
diff --git a/test/validation/timer/timer.h b/test/validation/timer/timer.h
index b18af80..5bdf908 100644
--- a/test/validation/timer/timer.h
+++ b/test/validation/timer/timer.h
@@ -4,4 +4,9 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */
 
+#ifndef _ODP_TEST_TIMER_H_
+#define _ODP_TEST_TIMER_H_
+
 int timer_main(void);
+
+#endif