diff --git a/test/validation/buffer/Makefile.am b/test/validation/buffer/Makefile.am
index e1b1233..05da40b 100644
--- a/test/validation/buffer/Makefile.am
+++ b/test/validation/buffer/Makefile.am
@@ -6,3 +6,5 @@ libbuffer_la_SOURCES = buffer.c
 bin_PROGRAMS = buffer_main$(EXEEXT)
 dist_buffer_main_SOURCES = buffer_main.c
 buffer_main_LDADD = libbuffer.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = buffer.h
diff --git a/test/validation/classification/Makefile.am b/test/validation/classification/Makefile.am
index ba468fa..7ab1dd9 100644
--- a/test/validation/classification/Makefile.am
+++ b/test/validation/classification/Makefile.am
@@ -8,3 +8,5 @@ libclassification_la_SOURCES = odp_classification_basic.c \
 bin_PROGRAMS = classification_main$(EXEEXT)
 dist_classification_main_SOURCES = classification_main.c
 classification_main_LDADD = libclassification.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = classification.h odp_classification_testsuites.h
diff --git a/test/validation/common/Makefile.am b/test/validation/common/Makefile.am
index 2cb0956..fd41fb4 100644
--- a/test/validation/common/Makefile.am
+++ b/test/validation/common/Makefile.am
@@ -9,3 +9,5 @@ libcpumask_common_la_SOURCES = mask_common.c
 
 libthrmask_common_la_SOURCES = mask_common.c
 libthrmask_common_la_CFLAGS = $(AM_CFLAGS) -DTEST_THRMASK
+
+EXTRA_DIST = mask_common.h odp_cunit_common.h
diff --git a/test/validation/cpumask/Makefile.am b/test/validation/cpumask/Makefile.am
index 795d9ff..5a05c7a 100644
--- a/test/validation/cpumask/Makefile.am
+++ b/test/validation/cpumask/Makefile.am
@@ -7,3 +7,5 @@ libcpumask_la_LIBADD = $(LIBCPUMASK_COMMON)
 bin_PROGRAMS = cpumask_main$(EXEEXT)
 dist_cpumask_main_SOURCES = cpumask_main.c
 cpumask_main_LDADD = libcpumask.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = cpumask.h
diff --git a/test/validation/crypto/Makefile.am b/test/validation/crypto/Makefile.am
index 6c7a94b..ee04d34 100644
--- a/test/validation/crypto/Makefile.am
+++ b/test/validation/crypto/Makefile.am
@@ -7,3 +7,5 @@ libcrypto_la_SOURCES = crypto.c \
 bin_PROGRAMS = crypto_main$(EXEEXT)
 dist_crypto_main_SOURCES = crypto_main.c
 crypto_main_LDADD = libcrypto.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = crypto.h odp_crypto_test_inp.h test_vectors.h test_vectors_len.h
diff --git a/test/validation/errno/Makefile.am b/test/validation/errno/Makefile.am
index ab3ef88..44575d9 100644
--- a/test/validation/errno/Makefile.am
+++ b/test/validation/errno/Makefile.am
@@ -6,3 +6,5 @@ liberrno_la_SOURCES = errno.c
 bin_PROGRAMS = errno_main$(EXEEXT)
 dist_errno_main_SOURCES = errno_main.c
 errno_main_LDADD = liberrno.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = errno.h
diff --git a/test/validation/init/Makefile.am b/test/validation/init/Makefile.am
index a54e29a..51cb4ad 100644
--- a/test/validation/init/Makefile.am
+++ b/test/validation/init/Makefile.am
@@ -12,3 +12,5 @@ dist_init_main_ok_SOURCES    = init_main_ok.c
 init_main_abort_LDADD = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
 init_main_log_LDADD   = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
 init_main_ok_LDADD    = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = init.h
diff --git a/test/validation/packet/Makefile.am b/test/validation/packet/Makefile.am
index 7ba7a47..9c783d5 100644
--- a/test/validation/packet/Makefile.am
+++ b/test/validation/packet/Makefile.am
@@ -6,3 +6,5 @@ libpacket_la_SOURCES = packet.c
 bin_PROGRAMS = packet_main$(EXEEXT)
 dist_packet_main_SOURCES = packet_main.c
 packet_main_LDADD = libpacket.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = packet.h
diff --git a/test/validation/pktio/Makefile.am b/test/validation/pktio/Makefile.am
index 86127a1..37efeaa 100644
--- a/test/validation/pktio/Makefile.am
+++ b/test/validation/pktio/Makefile.am
@@ -6,3 +6,5 @@ libpktio_la_SOURCES = pktio.c
 bin_PROGRAMS = pktio_main$(EXEEXT)
 dist_pktio_main_SOURCES = pktio_main.c
 pktio_main_LDADD = libpktio.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = pktio.h
diff --git a/test/validation/pool/Makefile.am b/test/validation/pool/Makefile.am
index 97f3eb4..8f626e7 100644
--- a/test/validation/pool/Makefile.am
+++ b/test/validation/pool/Makefile.am
@@ -6,3 +6,5 @@ libpool_la_SOURCES = pool.c
 bin_PROGRAMS = pool_main$(EXEEXT)
 dist_pool_main_SOURCES = pool_main.c
 pool_main_LDADD = libpool.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = pool.h
diff --git a/test/validation/queue/Makefile.am b/test/validation/queue/Makefile.am
index adeefc7..c4e5f96 100644
--- a/test/validation/queue/Makefile.am
+++ b/test/validation/queue/Makefile.am
@@ -6,3 +6,5 @@ libqueue_la_SOURCES = queue.c
 bin_PROGRAMS = queue_main$(EXEEXT)
 dist_queue_main_SOURCES = queue_main.c
 queue_main_LDADD = libqueue.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = queue.h
diff --git a/test/validation/random/Makefile.am b/test/validation/random/Makefile.am
index 85056d5..8f871bc 100644
--- a/test/validation/random/Makefile.am
+++ b/test/validation/random/Makefile.am
@@ -6,3 +6,5 @@ librandom_la_SOURCES = random.c
 bin_PROGRAMS = random_main$(EXEEXT)
 dist_random_main_SOURCES = random_main.c
 random_main_LDADD = librandom.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = random.h
diff --git a/test/validation/scheduler/Makefile.am b/test/validation/scheduler/Makefile.am
index d569691..e3947fa 100644
--- a/test/validation/scheduler/Makefile.am
+++ b/test/validation/scheduler/Makefile.am
@@ -6,3 +6,5 @@ libscheduler_la_SOURCES = scheduler.c
 bin_PROGRAMS = scheduler_main$(EXEEXT)
 dist_scheduler_main_SOURCES = scheduler_main.c
 scheduler_main_LDADD = libscheduler.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = scheduler.h
diff --git a/test/validation/shmem/Makefile.am b/test/validation/shmem/Makefile.am
index d81303d..b2d94ed 100644
--- a/test/validation/shmem/Makefile.am
+++ b/test/validation/shmem/Makefile.am
@@ -6,3 +6,5 @@ libshmem_la_SOURCES = shmem.c
 bin_PROGRAMS = shmem_main$(EXEEXT)
 dist_shmem_main_SOURCES = shmem_main.c
 shmem_main_LDADD = libshmem.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = shmem.h
diff --git a/test/validation/synchronizers/Makefile.am b/test/validation/synchronizers/Makefile.am
index ecb9886..4cd313c 100644
--- a/test/validation/synchronizers/Makefile.am
+++ b/test/validation/synchronizers/Makefile.am
@@ -6,3 +6,5 @@ libsynchronizers_la_SOURCES = synchronizers.c
 bin_PROGRAMS = synchronizers_main$(EXEEXT)
 dist_synchronizers_main_SOURCES = synchronizers_main.c
 synchronizers_main_LDADD = libsynchronizers.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = synchronizers.h
diff --git a/test/validation/system/Makefile.am b/test/validation/system/Makefile.am
index dd7759c..1c7de86 100644
--- a/test/validation/system/Makefile.am
+++ b/test/validation/system/Makefile.am
@@ -6,3 +6,5 @@ libsystem_la_SOURCES = system.c
 bin_PROGRAMS = system_main$(EXEEXT)
 dist_system_main_SOURCES = system_main.c
 system_main_LDADD = libsystem.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = system.h
diff --git a/test/validation/thread/Makefile.am b/test/validation/thread/Makefile.am
index c18bc50..20b7f13 100644
--- a/test/validation/thread/Makefile.am
+++ b/test/validation/thread/Makefile.am
@@ -8,3 +8,5 @@ libthread_la_LIBADD = $(LIBTHRMASK_COMMON)
 bin_PROGRAMS = thread_main$(EXEEXT)
 dist_thread_main_SOURCES = thread_main.c
 thread_main_LDADD = libthread.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = thread.h
diff --git a/test/validation/time/Makefile.am b/test/validation/time/Makefile.am
index 418107d..0e8742e 100644
--- a/test/validation/time/Makefile.am
+++ b/test/validation/time/Makefile.am
@@ -6,3 +6,5 @@ libtime_la_SOURCES = time.c
 bin_PROGRAMS = time_main$(EXEEXT)
 dist_time_main_SOURCES = time_main.c
 time_main_LDADD = libtime.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = time.h
diff --git a/test/validation/timer/Makefile.am b/test/validation/timer/Makefile.am
index 591dfb6..01e4fd3 100644
--- a/test/validation/timer/Makefile.am
+++ b/test/validation/timer/Makefile.am
@@ -6,3 +6,5 @@ libtimer_la_SOURCES = timer.c
 bin_PROGRAMS = timer_main$(EXEEXT)
 dist_timer_main_SOURCES = timer_main.c
 timer_main_LDADD = libtimer.la $(LIBCUNIT_COMMON) $(LIBODP)
+
+EXTRA_DIST = timer.h