diff --git a/test/validation/buffer/Makefile.am b/test/validation/buffer/Makefile.am
index 05da40b..10ee887 100644
--- a/test/validation/buffer/Makefile.am
+++ b/test/validation/buffer/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libbuffer.la
-libbuffer_la_SOURCES = buffer.c
+noinst_LTLIBRARIES = libodpbuffer.la
+libodpbuffer_la_SOURCES = buffer.c
 
 bin_PROGRAMS = buffer_main$(EXEEXT)
 dist_buffer_main_SOURCES = buffer_main.c
-buffer_main_LDADD = libbuffer.la $(LIBCUNIT_COMMON) $(LIBODP)
+buffer_main_LDADD = libodpbuffer.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = buffer.h
diff --git a/test/validation/classification/Makefile.am b/test/validation/classification/Makefile.am
index 7ab1dd9..db5ca81 100644
--- a/test/validation/classification/Makefile.am
+++ b/test/validation/classification/Makefile.am
@@ -1,12 +1,12 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libclassification.la
-libclassification_la_SOURCES = odp_classification_basic.c \
+noinst_LTLIBRARIES = libodpclassification.la
+libodpclassification_la_SOURCES = odp_classification_basic.c \
 			       odp_classification_tests.c \
 			       classification.c
 
 bin_PROGRAMS = classification_main$(EXEEXT)
 dist_classification_main_SOURCES = classification_main.c
-classification_main_LDADD = libclassification.la $(LIBCUNIT_COMMON) $(LIBODP)
+classification_main_LDADD = libodpclassification.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = classification.h odp_classification_testsuites.h
diff --git a/test/validation/cpumask/Makefile.am b/test/validation/cpumask/Makefile.am
index 5a05c7a..34baaab 100644
--- a/test/validation/cpumask/Makefile.am
+++ b/test/validation/cpumask/Makefile.am
@@ -1,11 +1,11 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libcpumask.la
-libcpumask_la_SOURCES = cpumask.c
-libcpumask_la_LIBADD = $(LIBCPUMASK_COMMON)
+noinst_LTLIBRARIES = libodpcpumask.la
+libodpcpumask_la_SOURCES = cpumask.c
+libodpcpumask_la_LIBADD = $(LIBCPUMASK_COMMON)
 
 bin_PROGRAMS = cpumask_main$(EXEEXT)
 dist_cpumask_main_SOURCES = cpumask_main.c
-cpumask_main_LDADD = libcpumask.la $(LIBCUNIT_COMMON) $(LIBODP)
+cpumask_main_LDADD = libodpcpumask.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = cpumask.h
diff --git a/test/validation/crypto/Makefile.am b/test/validation/crypto/Makefile.am
index ee04d34..bd0a7cd 100644
--- a/test/validation/crypto/Makefile.am
+++ b/test/validation/crypto/Makefile.am
@@ -1,11 +1,11 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libcrypto.la
-libcrypto_la_SOURCES = crypto.c \
+noinst_LTLIBRARIES = libodpcrypto.la
+libodpcrypto_la_SOURCES = crypto.c \
 		       odp_crypto_test_inp.c
 
 bin_PROGRAMS = crypto_main$(EXEEXT)
 dist_crypto_main_SOURCES = crypto_main.c
-crypto_main_LDADD = libcrypto.la $(LIBCUNIT_COMMON) $(LIBODP)
+crypto_main_LDADD = libodpcrypto.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = crypto.h odp_crypto_test_inp.h test_vectors.h test_vectors_len.h
diff --git a/test/validation/errno/Makefile.am b/test/validation/errno/Makefile.am
index 44575d9..af060f5 100644
--- a/test/validation/errno/Makefile.am
+++ b/test/validation/errno/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = liberrno.la
-liberrno_la_SOURCES = errno.c
+noinst_LTLIBRARIES = libodperrno.la
+libodperrno_la_SOURCES = errno.c
 
 bin_PROGRAMS = errno_main$(EXEEXT)
 dist_errno_main_SOURCES = errno_main.c
-errno_main_LDADD = liberrno.la $(LIBCUNIT_COMMON) $(LIBODP)
+errno_main_LDADD = libodperrno.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = errno.h
diff --git a/test/validation/init/Makefile.am b/test/validation/init/Makefile.am
index 51cb4ad..f21a844 100644
--- a/test/validation/init/Makefile.am
+++ b/test/validation/init/Makefile.am
@@ -1,6 +1,6 @@
 include ../Makefile.inc
-noinst_LTLIBRARIES = libinit.la
-libinit_la_SOURCES = init.c
+noinst_LTLIBRARIES = libodpinit.la
+libodpinit_la_SOURCES = init.c
 
 # most platforms are expected not to support multiple ODP inits
 # following each other: therefore 3 separate binaries are
@@ -9,8 +9,8 @@ bin_PROGRAMS = init_main_abort$(EXEEXT) init_main_log$(EXEEXT) init_main_ok$(EXE
 dist_init_main_abort_SOURCES = init_main_abort.c
 dist_init_main_log_SOURCES   = init_main_log.c
 dist_init_main_ok_SOURCES    = init_main_ok.c
-init_main_abort_LDADD = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
-init_main_log_LDADD   = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
-init_main_ok_LDADD    = libinit.la $(LIBCUNIT_COMMON) $(LIBODP)
+init_main_abort_LDADD = libodpinit.la $(LIBCUNIT_COMMON) $(LIBODP)
+init_main_log_LDADD   = libodpinit.la $(LIBCUNIT_COMMON) $(LIBODP)
+init_main_ok_LDADD    = libodpinit.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = init.h
diff --git a/test/validation/packet/Makefile.am b/test/validation/packet/Makefile.am
index 9c783d5..76178ff 100644
--- a/test/validation/packet/Makefile.am
+++ b/test/validation/packet/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libpacket.la
-libpacket_la_SOURCES = packet.c
+noinst_LTLIBRARIES = libodppacket.la
+libodppacket_la_SOURCES = packet.c
 
 bin_PROGRAMS = packet_main$(EXEEXT)
 dist_packet_main_SOURCES = packet_main.c
-packet_main_LDADD = libpacket.la $(LIBCUNIT_COMMON) $(LIBODP)
+packet_main_LDADD = libodppacket.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = packet.h
diff --git a/test/validation/pktio/Makefile.am b/test/validation/pktio/Makefile.am
index 37efeaa..094b4be 100644
--- a/test/validation/pktio/Makefile.am
+++ b/test/validation/pktio/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libpktio.la
-libpktio_la_SOURCES = pktio.c
+noinst_LTLIBRARIES = libodppktio.la
+libodppktio_la_SOURCES = pktio.c
 
 bin_PROGRAMS = pktio_main$(EXEEXT)
 dist_pktio_main_SOURCES = pktio_main.c
-pktio_main_LDADD = libpktio.la $(LIBCUNIT_COMMON) $(LIBODP)
+pktio_main_LDADD = libodppktio.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = pktio.h
diff --git a/test/validation/pool/Makefile.am b/test/validation/pool/Makefile.am
index 8f626e7..5b95b41 100644
--- a/test/validation/pool/Makefile.am
+++ b/test/validation/pool/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libpool.la
-libpool_la_SOURCES = pool.c
+noinst_LTLIBRARIES = libodppool.la
+libodppool_la_SOURCES = pool.c
 
 bin_PROGRAMS = pool_main$(EXEEXT)
 dist_pool_main_SOURCES = pool_main.c
-pool_main_LDADD = libpool.la $(LIBCUNIT_COMMON) $(LIBODP)
+pool_main_LDADD = libodppool.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = pool.h
diff --git a/test/validation/queue/Makefile.am b/test/validation/queue/Makefile.am
index c4e5f96..2570df4 100644
--- a/test/validation/queue/Makefile.am
+++ b/test/validation/queue/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libqueue.la
-libqueue_la_SOURCES = queue.c
+noinst_LTLIBRARIES = libodpqueue.la
+libodpqueue_la_SOURCES = queue.c
 
 bin_PROGRAMS = queue_main$(EXEEXT)
 dist_queue_main_SOURCES = queue_main.c
-queue_main_LDADD = libqueue.la $(LIBCUNIT_COMMON) $(LIBODP)
+queue_main_LDADD = libodpqueue.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = queue.h
diff --git a/test/validation/random/Makefile.am b/test/validation/random/Makefile.am
index 8f871bc..4749447 100644
--- a/test/validation/random/Makefile.am
+++ b/test/validation/random/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = librandom.la
-librandom_la_SOURCES = random.c
+noinst_LTLIBRARIES = libodprandom.la
+libodprandom_la_SOURCES = random.c
 
 bin_PROGRAMS = random_main$(EXEEXT)
 dist_random_main_SOURCES = random_main.c
-random_main_LDADD = librandom.la $(LIBCUNIT_COMMON) $(LIBODP)
+random_main_LDADD = libodprandom.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = random.h
diff --git a/test/validation/scheduler/Makefile.am b/test/validation/scheduler/Makefile.am
index e3947fa..b1b9790 100644
--- a/test/validation/scheduler/Makefile.am
+++ b/test/validation/scheduler/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libscheduler.la
-libscheduler_la_SOURCES = scheduler.c
+noinst_LTLIBRARIES = libodpscheduler.la
+libodpscheduler_la_SOURCES = scheduler.c
 
 bin_PROGRAMS = scheduler_main$(EXEEXT)
 dist_scheduler_main_SOURCES = scheduler_main.c
-scheduler_main_LDADD = libscheduler.la $(LIBCUNIT_COMMON) $(LIBODP)
+scheduler_main_LDADD = libodpscheduler.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = scheduler.h
diff --git a/test/validation/shmem/Makefile.am b/test/validation/shmem/Makefile.am
index b2d94ed..e4565de 100644
--- a/test/validation/shmem/Makefile.am
+++ b/test/validation/shmem/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libshmem.la
-libshmem_la_SOURCES = shmem.c
+noinst_LTLIBRARIES = libodpshmem.la
+libodpshmem_la_SOURCES = shmem.c
 
 bin_PROGRAMS = shmem_main$(EXEEXT)
 dist_shmem_main_SOURCES = shmem_main.c
-shmem_main_LDADD = libshmem.la $(LIBCUNIT_COMMON) $(LIBODP)
+shmem_main_LDADD = libodpshmem.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = shmem.h
diff --git a/test/validation/synchronizers/Makefile.am b/test/validation/synchronizers/Makefile.am
index 4cd313c..34240ec 100644
--- a/test/validation/synchronizers/Makefile.am
+++ b/test/validation/synchronizers/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libsynchronizers.la
-libsynchronizers_la_SOURCES = synchronizers.c
+noinst_LTLIBRARIES = libodpsynchronizers.la
+libodpsynchronizers_la_SOURCES = synchronizers.c
 
 bin_PROGRAMS = synchronizers_main$(EXEEXT)
 dist_synchronizers_main_SOURCES = synchronizers_main.c
-synchronizers_main_LDADD = libsynchronizers.la $(LIBCUNIT_COMMON) $(LIBODP)
+synchronizers_main_LDADD = libodpsynchronizers.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = synchronizers.h
diff --git a/test/validation/system/Makefile.am b/test/validation/system/Makefile.am
index 1c7de86..a5aaa25 100644
--- a/test/validation/system/Makefile.am
+++ b/test/validation/system/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libsystem.la
-libsystem_la_SOURCES = system.c
+noinst_LTLIBRARIES = libodpsystem.la
+libodpsystem_la_SOURCES = system.c
 
 bin_PROGRAMS = system_main$(EXEEXT)
 dist_system_main_SOURCES = system_main.c
-system_main_LDADD = libsystem.la $(LIBCUNIT_COMMON) $(LIBODP)
+system_main_LDADD = libodpsystem.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = system.h
diff --git a/test/validation/thread/Makefile.am b/test/validation/thread/Makefile.am
index 20b7f13..24b6f35 100644
--- a/test/validation/thread/Makefile.am
+++ b/test/validation/thread/Makefile.am
@@ -1,12 +1,12 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libthread.la
-libthread_la_SOURCES = thread.c
-libthread_la_CFLAGS = $(AM_CFLAGS) -DTEST_THRMASK
-libthread_la_LIBADD = $(LIBTHRMASK_COMMON)
+noinst_LTLIBRARIES = libodpthread.la
+libodpthread_la_SOURCES = thread.c
+libodpthread_la_CFLAGS = $(AM_CFLAGS) -DTEST_THRMASK
+libodpthread_la_LIBADD = $(LIBTHRMASK_COMMON)
 
 bin_PROGRAMS = thread_main$(EXEEXT)
 dist_thread_main_SOURCES = thread_main.c
-thread_main_LDADD = libthread.la $(LIBCUNIT_COMMON) $(LIBODP)
+thread_main_LDADD = libodpthread.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = thread.h
diff --git a/test/validation/time/Makefile.am b/test/validation/time/Makefile.am
index 0e8742e..f207fe8 100644
--- a/test/validation/time/Makefile.am
+++ b/test/validation/time/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtime.la
-libtime_la_SOURCES = time.c
+noinst_LTLIBRARIES = libodptime.la
+libodptime_la_SOURCES = time.c
 
 bin_PROGRAMS = time_main$(EXEEXT)
 dist_time_main_SOURCES = time_main.c
-time_main_LDADD = libtime.la $(LIBCUNIT_COMMON) $(LIBODP)
+time_main_LDADD = libodptime.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = time.h
diff --git a/test/validation/timer/Makefile.am b/test/validation/timer/Makefile.am
index 01e4fd3..e28cdee 100644
--- a/test/validation/timer/Makefile.am
+++ b/test/validation/timer/Makefile.am
@@ -1,10 +1,10 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtimer.la
-libtimer_la_SOURCES = timer.c
+noinst_LTLIBRARIES = libodptimer.la
+libodptimer_la_SOURCES = timer.c
 
 bin_PROGRAMS = timer_main$(EXEEXT)
 dist_timer_main_SOURCES = timer_main.c
-timer_main_LDADD = libtimer.la $(LIBCUNIT_COMMON) $(LIBODP)
+timer_main_LDADD = libodptimer.la $(LIBCUNIT_COMMON) $(LIBODP)
 
 EXTRA_DIST = timer.h